#include "EsoAcsammm_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void t1_res_block_0(double* yy, double* t1_yy, double* der_x, double* t1_der_x, double* x, double* t1_x, double* p, double* t1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c, int& n_yy_ind, int* yy_ind, int& i_E_start, int& i_E_end)
#pragma ad indep x t1_x p t1_p
#pragma ad dep yy t1_yy
{
   int i_E=0; 
   int i_C=0; 
   int i__=0; 
   int j__=0; 
   int k__=0; 
   int m__=0; 
   int r_i=0; 
   int r_j=0; 
   int i_a=0; 
   int i_b=0; 
   int i_loop=0; 
   int i__switch=0; 
   int i__start=0; 
   int i__end=0; 
   int i__step=0; 
   int while_end=0; 
   int i_cont=0; 
   int j_cont=0; 
   int k_cont=0; 
   double var_pi=0; 
   double t1_var_pi=0; 
   double par_accel=0; 
   double t1_par_accel=0; 
   double par_alpha=0; 
   double t1_par_alpha=0; 
   double par_tf=0; 
   double t1_par_tf=0; 
   double var_ttime=0; 
   double t1_var_ttime=0; 
   double der_var_ttime=0; 
   double t1_der_var_ttime=0; 
   double var_velo=0; 
   double t1_var_velo=0; 
   double der_var_velo=0; 
   double t1_der_var_velo=0; 
   double var_dist=0; 
   double t1_var_dist=0; 
   double der_var_dist=0; 
   double t1_der_var_dist=0; 
   double var_obj=0; 
   double t1_var_obj=0; 
   double der_var_obj=0; 
   double t1_der_var_obj=0; 
   int i_i=0; 
   int i_j=0; 
   int i_z=0; 
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0; 
   double v1_3=0; 
   double t1_v1_3=0; 
   double v1_4=0; 
   double t1_v1_4=0; 
   double v1_5=0; 
   double t1_v1_5=0; 
   double v1_6=0; 
   double t1_v1_6=0; 
   double v1_7=0; 
   double t1_v1_7=0; 
   double v1_8=0; 
   double t1_v1_8=0; 
   double v1_9=0; 
   double t1_v1_9=0; 
   double v1_10=0; 
   double t1_v1_10=0; 
   double v1_11=0; 
   double t1_v1_11=0; 
   double v1_12=0; 
   double t1_v1_12=0; 
   t1_v1_0=0;  // TLM constant reference
   v1_0=3.14159;  // SAC constant reference
   t1_var_pi=t1_v1_0; // TLM =
   var_pi=v1_0; // SAC =
   t1_v1_0=t1_p[0]; // TLM array memory reference
   v1_0=p[0]; // SAC array memory reference
   t1_par_accel=t1_v1_0; // TLM =
   par_accel=v1_0; // SAC =
   t1_v1_0=t1_p[1]; // TLM array memory reference
   v1_0=p[1]; // SAC array memory reference
   t1_par_alpha=t1_v1_0; // TLM =
   par_alpha=v1_0; // SAC =
   t1_v1_0=t1_p[2]; // TLM array memory reference
   v1_0=p[2]; // SAC array memory reference
   t1_par_tf=t1_v1_0; // TLM =
   par_tf=v1_0; // SAC =
   t1_v1_0=t1_x[0]; // TLM array memory reference
   v1_0=x[0]; // SAC array memory reference
   t1_var_ttime=t1_v1_0; // TLM =
   var_ttime=v1_0; // SAC =
   t1_v1_0=t1_der_x[0]; // TLM array memory reference
   v1_0=der_x[0]; // SAC array memory reference
   t1_der_var_ttime=t1_v1_0; // TLM =
   der_var_ttime=v1_0; // SAC =
   t1_v1_0=t1_x[1]; // TLM array memory reference
   v1_0=x[1]; // SAC array memory reference
   t1_var_velo=t1_v1_0; // TLM =
   var_velo=v1_0; // SAC =
   t1_v1_0=t1_der_x[1]; // TLM array memory reference
   v1_0=der_x[1]; // SAC array memory reference
   t1_der_var_velo=t1_v1_0; // TLM =
   der_var_velo=v1_0; // SAC =
   t1_v1_0=t1_x[2]; // TLM array memory reference
   v1_0=x[2]; // SAC array memory reference
   t1_var_dist=t1_v1_0; // TLM =
   var_dist=v1_0; // SAC =
   t1_v1_0=t1_der_x[2]; // TLM array memory reference
   v1_0=der_x[2]; // SAC array memory reference
   t1_der_var_dist=t1_v1_0; // TLM =
   der_var_dist=v1_0; // SAC =
   t1_v1_0=t1_x[3]; // TLM array memory reference
   v1_0=x[3]; // SAC array memory reference
   t1_var_obj=t1_v1_0; // TLM =
   var_obj=v1_0; // SAC =
   t1_v1_0=t1_der_x[3]; // TLM array memory reference
   v1_0=der_x[3]; // SAC array memory reference
   t1_der_var_obj=t1_v1_0; // TLM =
   der_var_obj=v1_0; // SAC =
   // nonfloat assignment
   i_E=i_E_start;
   while (i_E<i_E_end) {
      // nonfloat assignment
      i__switch=yy_ind[i_E];
      switch (i__switch) {
         case 0: {
            t1_v1_0=t1_der_var_dist; // TLM scalar memory reference
            v1_0=der_var_dist; // SAC scalar memory reference
            t1_v1_1=t1_par_tf; // TLM scalar memory reference
            v1_1=par_tf; // SAC scalar memory reference
            t1_v1_2=t1_var_velo; // TLM scalar memory reference
            v1_2=var_velo; // SAC scalar memory reference
            t1_v1_3=v1_2*t1_v1_1+v1_1*t1_v1_2; // TLM *
            v1_3=v1_1*v1_2; // SAC *
            t1_v1_4=t1_v1_3; // TLM ()
            v1_4=v1_3; // SAC ()
            t1_v1_5=t1_v1_0-t1_v1_4; // TLM -
            v1_5=v1_0-v1_4; // SAC -
            t1_yy[i_E]=t1_v1_5; // TLM =
            yy[i_E]=v1_5; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 1: {
            t1_v1_0=t1_der_var_ttime; // TLM scalar memory reference
            v1_0=der_var_ttime; // SAC scalar memory reference
            t1_v1_1=t1_par_tf; // TLM scalar memory reference
            v1_1=par_tf; // SAC scalar memory reference
            t1_v1_2=0;  // TLM constant reference
            v1_2=1;  // SAC constant reference
            t1_v1_3=v1_2*t1_v1_1+v1_1*t1_v1_2; // TLM *
            v1_3=v1_1*v1_2; // SAC *
            t1_v1_4=t1_v1_3; // TLM ()
            v1_4=v1_3; // SAC ()
            t1_v1_5=t1_v1_0-t1_v1_4; // TLM -
            v1_5=v1_0-v1_4; // SAC -
            t1_yy[i_E]=t1_v1_5; // TLM =
            yy[i_E]=v1_5; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 2: {
            t1_v1_0=t1_der_var_velo; // TLM scalar memory reference
            v1_0=der_var_velo; // SAC scalar memory reference
            t1_v1_1=t1_par_tf; // TLM scalar memory reference
            v1_1=par_tf; // SAC scalar memory reference
            t1_v1_2=t1_par_accel; // TLM scalar memory reference
            v1_2=par_accel; // SAC scalar memory reference
            t1_v1_3=t1_par_alpha; // TLM scalar memory reference
            v1_3=par_alpha; // SAC scalar memory reference
            t1_v1_4=t1_var_velo; // TLM scalar memory reference
            v1_4=var_velo; // SAC scalar memory reference
            t1_v1_5=v1_4*t1_v1_3+v1_3*t1_v1_4; // TLM *
            v1_5=v1_3*v1_4; // SAC *
            t1_v1_6=t1_var_velo; // TLM scalar memory reference
            v1_6=var_velo; // SAC scalar memory reference
            t1_v1_7=v1_6*t1_v1_5+v1_5*t1_v1_6; // TLM *
            v1_7=v1_5*v1_6; // SAC *
            t1_v1_8=t1_v1_2-t1_v1_7; // TLM -
            v1_8=v1_2-v1_7; // SAC -
            t1_v1_9=t1_v1_8; // TLM ()
            v1_9=v1_8; // SAC ()
            t1_v1_10=v1_9*t1_v1_1+v1_1*t1_v1_9; // TLM *
            v1_10=v1_1*v1_9; // SAC *
            t1_v1_11=t1_v1_10; // TLM ()
            v1_11=v1_10; // SAC ()
            t1_v1_12=t1_v1_0-t1_v1_11; // TLM -
            v1_12=v1_0-v1_11; // SAC -
            t1_yy[i_E]=t1_v1_12; // TLM =
            yy[i_E]=v1_12; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 3: {
            t1_v1_0=t1_var_obj; // TLM scalar memory reference
            v1_0=var_obj; // SAC scalar memory reference
            t1_v1_1=t1_var_ttime; // TLM scalar memory reference
            v1_1=var_ttime; // SAC scalar memory reference
            t1_v1_2=0-t1_v1_1; // TLM -
            v1_2=0-v1_1; // SAC -
            t1_v1_3=t1_v1_2; // TLM ()
            v1_3=v1_2; // SAC ()
            t1_v1_4=t1_v1_0-t1_v1_3; // TLM -
            v1_4=v1_0-v1_3; // SAC -
            t1_yy[i_E]=t1_v1_4; // TLM =
            yy[i_E]=v1_4; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
      }
   }
}
void t1_res_block(double* yy, double* t1_yy, double* der_x, double* t1_der_x, double* x, double* t1_x, double* p, double* t1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c, int& n_yy_ind, int* yy_ind)
#pragma ad indep x t1_x p t1_p
#pragma ad dep yy t1_yy
{
   int i_E=0; 
   int i_E_end=4; 
   int i__start=0; 
   int i__end=0; 
   int i__switch=0; 
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0; 
   double v1_3=0; 
   double t1_v1_3=0; 
   while (i_E<n_yy_ind) {
      // nonfloat assignment
      i__switch=yy_ind[i_E];
      // nonfloat assignment
      i__start=0;
      // nonfloat assignment
      i__end=4;
      if ((i__switch>=i__start) && (i__switch<i__end)) {
         // nonfloat assignment
         i__end=i_E+1;
         t1_res_block_0(yy,t1_yy,der_x,t1_der_x,x,t1_x,p,t1_p,condit,lock,prev,n_x,n_p,n_c,n_yy_ind,yy_ind,i_E,i__end);
      }
      // nonfloat assignment
      i_E=i_E+1;
   }
}
